Loading...
Searching...
No Matches
Halide::ExternFuncArgument Struct Reference

An argument to an extern-defined Func. More...

`#include <ExternFuncArgument.h>`

## Public Types

enum | ArgType { UndefinedArg = 0 , FuncArg , BufferArg , ExprArg , ImageParamArg }

## Public Member Functions

| ExternFuncArgument (Internal::FunctionPtr f)
template<typename T, int Dims>
| ExternFuncArgument (const Buffer< T, Dims > &b)
| ExternFuncArgument (Expr e)
| ExternFuncArgument (int e)
| ExternFuncArgument (float e)
| ExternFuncArgument (const Parameter &p)
| ExternFuncArgument ()=default
bool | is_func () const
bool | is_expr () const
bool | is_buffer () const
bool | is_image_param () const
bool | defined () const

## Public Attributes

ArgType | arg_type = UndefinedArg
Internal::FunctionPtr | func
Buffer | buffer
Expr | expr
Parameter | image_param

## Detailed Description

An argument to an extern-defined Func.

May be a Function, Buffer, ImageParam or Expr.

Definition at line 17 of file ExternFuncArgument.h.

## Member Enumeration Documentation

## ArgType

enum Halide::ExternFuncArgument::ArgType

Enumerator
UndefinedArg |
FuncArg |
BufferArg |
ExprArg |
ImageParamArg |

Definition at line 18 of file ExternFuncArgument.h.

## Constructor & Destructor Documentation

## ExternFuncArgument() [1/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( | Internal::FunctionPtr | f | ) |

inline

Definition at line 29 of file ExternFuncArgument.h.

References arg_type, func, and FuncArg.

## ExternFuncArgument() [2/7]

template<typename T, int Dims>

Halide::ExternFuncArgument::ExternFuncArgument | ( | const Buffer< T, Dims > & | b | ) |

inline

Definition at line 34 of file ExternFuncArgument.h.

References arg_type, buffer, and BufferArg.

## ExternFuncArgument() [3/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( | Expr | e | ) |

inline

Definition at line 37 of file ExternFuncArgument.h.

References arg_type, expr, and ExprArg.

## ExternFuncArgument() [4/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( | int | e | ) |

inline

Definition at line 40 of file ExternFuncArgument.h.

References arg_type, expr, and ExprArg.

## ExternFuncArgument() [5/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( | float | e | ) |

inline

Definition at line 43 of file ExternFuncArgument.h.

References arg_type, expr, and ExprArg.

## ExternFuncArgument() [6/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( | const Parameter & | p | ) |

inline

Definition at line 47 of file ExternFuncArgument.h.

References arg_type, image_param, ImageParamArg, internal_assert, and Halide::Parameter::is_buffer().

## ExternFuncArgument() [7/7]

Halide::ExternFuncArgument::ExternFuncArgument | ( |  | ) |

default

## Member Function Documentation

## is_func()

bool Halide::ExternFuncArgument::is_func | ( |  | ) | const

inline

Definition at line 54 of file ExternFuncArgument.h.

References arg_type, and FuncArg.

## is_expr()

bool Halide::ExternFuncArgument::is_expr | ( |  | ) | const

inline

Definition at line 57 of file ExternFuncArgument.h.

References arg_type, and ExprArg.

## is_buffer()

bool Halide::ExternFuncArgument::is_buffer | ( |  | ) | const

inline

Definition at line 60 of file ExternFuncArgument.h.

References arg_type, and BufferArg.

## is_image_param()

bool Halide::ExternFuncArgument::is_image_param | ( |  | ) | const

inline

Definition at line 63 of file ExternFuncArgument.h.

References arg_type, and ImageParamArg.

## defined()

bool Halide::ExternFuncArgument::defined | ( |  | ) | const

inline

Definition at line 66 of file ExternFuncArgument.h.

References arg_type, and UndefinedArg.

## Member Data Documentation

## arg_type

ArgType Halide::ExternFuncArgument::arg_type = UndefinedArg

Definition at line 23 of file ExternFuncArgument.h.

Referenced by defined(), ExternFuncArgument(), ExternFuncArgument(), ExternFuncArgument(), ExternFuncArgument(), ExternFuncArgument(), ExternFuncArgument(), is_buffer(), is_expr(), is_func(), and is_image_param().

## func

Internal::FunctionPtr Halide::ExternFuncArgument::func

Definition at line 24 of file ExternFuncArgument.h.

Referenced by ExternFuncArgument().

## buffer

Buffer Halide::ExternFuncArgument::buffer

Definition at line 25 of file ExternFuncArgument.h.

Referenced by ExternFuncArgument().

## expr

Expr Halide::ExternFuncArgument::expr

Definition at line 26 of file ExternFuncArgument.h.

Referenced by ExternFuncArgument(), ExternFuncArgument(), and ExternFuncArgument().

## image_param

Parameter Halide::ExternFuncArgument::image_param

Definition at line 27 of file ExternFuncArgument.h.

Referenced by ExternFuncArgument().

The documentation for this struct was generated from the following file:

- src/ExternFuncArgument.h